/*
 * This file is generated by jOOQ.
*/
package cc.cinnamon.canary.users.model.tables.pojos


import cc.cinnamon.canary.users.model.tables.interfaces.IUsersRoles

import javax.annotation.Generated
import javax.validation.constraints.NotNull


/**
 * This class is generated by jOOQ.
 */
@Generated(value = *arrayOf("http://www.jooq.org", "jOOQ version:3.9.1", "schema version:public_4"), date = "2017-02-20T21:56:50.783Z", comments = "This class is generated by jOOQ")
class UsersRoles : IUsersRoles {

    override var id: Long? = null
    @get:NotNull
    override var userId: Long? = null
    @get:NotNull
    override var roleId: Long? = null

    constructor() {}

    constructor(value: UsersRoles) {
        this.id = value.id
        this.userId = value.userId
        this.roleId = value.roleId
    }

    constructor(
            id: Long?,
            userId: Long?,
            roleId: Long?
    ) {
        this.id = id
        this.userId = userId
        this.roleId = roleId
    }

    override fun equals(obj: Any?): Boolean {
        if (this === obj)
            return true
        if (obj == null)
            return false
        if (javaClass != obj.javaClass)
            return false
        val other = obj as UsersRoles?
        if (id == null) {
            if (other!!.id != null)
                return false
        } else if (id != other!!.id)
            return false
        if (userId == null) {
            if (other.userId != null)
                return false
        } else if (userId != other.userId)
            return false
        if (roleId == null) {
            if (other.roleId != null)
                return false
        } else if (roleId != other.roleId)
            return false
        return true
    }

    override fun hashCode(): Int {
        val prime = 31
        var result = 1
        result = prime * result + if (id == null) 0 else id!!.hashCode()
        result = prime * result + if (userId == null) 0 else userId!!.hashCode()
        result = prime * result + if (roleId == null) 0 else roleId!!.hashCode()
        return result
    }

    override fun toString(): String {
        val sb = StringBuilder("UsersRoles (")

        sb.append(id)
        sb.append(", ").append(userId)
        sb.append(", ").append(roleId)

        sb.append(")")
        return sb.toString()
    }

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    override fun from(from: IUsersRoles) {
        id = from.id
        userId = from.userId
        roleId = from.roleId
    }

    /**
     * {@inheritDoc}
     */
    override fun <E : IUsersRoles> into(into: E): E {
        into.from(this)
        return into
    }

    companion object {

        private val serialVersionUID: Long = -659790908
    }
}
